// HAL9000.js
// EJSE, Inc. <http://www.ejse.com>
//
// This software is freeware; distribute as a whole freely.
// Do not re-distribute individual resources or units separately.

// Resource directories
var imagesDir = "resources/images/";
var audioDir = "resources/audio/";

// Misc
var maxSounds = 8;
var counter = 0;
var lastSound = -1;

// Special sounds
var hal_operational_wav = "hal_operational.wav";
var hal_goodevening_wav = "hal_goodevening.wav";
var hal_justwhat_wav = "hal_justwhat.wav";

// Remaining sounds
var soundNames = new Array("hal_mindgoing.wav", "hal_goingwell.wav", "hal_daisy.wav", "hal_tracking.wav", "hal_9000series.wav", "hal_cantdothat.wav", "hal_fault.wav", "hal_disconnect.wav");

// Play the opening sound
if (new Date().getHours() > 16)
	playHalSoundByName(hal_goodevening_wav);
else
	playHalSoundByName(hal_operational_wav);

function mouseUp()
{
	if (getRandomNumber(10) > 5)
		playHalSoundByName(hal_justwhat_wav); // HAL doesn't like you touching him!  ;)
}

function timerTick()
{
	eye.opacity = 255 - (system.cpu.activity * 2.55); // The busier your computer is, the less HAL is there (because he's busy)

	counter++;
	if (counter == preferences.silenceDuration.value) 
	{
		var index;
		do
		{
			index = getRandomNumber(maxSounds);
		} 
		while (index == lastSound);
		playHalSoundByIndex(index);
		lastSound = index;
		counter = 0;
	}
}

function preferencesChanged()
{
	bevel.opacity = (preferences.showBevel.value == 1) ? 255 : 0;
}

function getRandomNumber(max)
{
	return Math.round(Math.random() * max)
}

function playHalSoundByName(fileName) 
{
	if (!system.mute)
		play(audioDir + fileName);
}

function playHalSoundByIndex(index)
{
	if ((index < 0) || (index > maxSounds))
		throw "ArgumentOutOfRange: index argument must be between 0-" + (maxSounds - 1);
	if (!system.mute)
		play(audioDir + soundNames[index]);
}